# Range minimum query

### From PEGWiki

The term **range minimum query (RMQ)** comprises all variations of the problem of finding the smallest element (or the position of the smallest element) in a contiguous subsequence of a list of items taken from a totally ordered set (usually numbers). This is one of the most extensively-studied problems in computer science, and many algorithms are known, each of which is appropriate for a specific variation.

A single range minimum query is a set of indices *i* < *j* into an array *A*; the answer to this query is some (see half-open interval) such that for all . In isolation, this query is answered simply by scanning through the range given and selecting the minimum element, which can take up to linear time. The problem is interesting because we often desire to answer a large number of queries, so that if, for example, 500000 queries are to be performed on a single array of 10000000 elements, then using this naive approach on each query individually is probably too slow.

## Contents |

## [edit] Static

In the *static range minimum query*, the input is an array and a set of intervals (contiguous subsequences) of the array, identified by their endpoints, and for each interval we must find the smallest element contained therein. Modifications to the array are not allowed, but we must be prepared to handle queries "on the fly"; that is, we might not know all of them at once.

### [edit] Sliding

This problem can be solved in linear time in the special case in which the intervals are guaranteed to be given in such an order that they are successive elements of a sliding window; that is, each interval given in input neither starts earlier nor ends later than the previous one. This is the sliding range minimum query problem; an algorithm is given in that article.

### [edit] Naive precomputation

This approach involves precomputing the minimum of every possible range in the given array and storing all the results in a table; this table will use up Θ(*n*^{2}) space but queries will be answerable in constant time. This table can also be computed in Θ(*n*^{2}) time by noting that the minimum of a range *A*_{i..j − 1} occurs either in the last element, *A*_{j − 1}, or in the rest of it, *A*_{i..j − 2}, so that given the minimum in range [*i*,*j* − 1) we can compute that of [*i*,*j*) in constant time.

Formally, we use the recurrence

### [edit] Division into blocks

In all other cases, we must consider other solutions. A simple solution for this and other related problems involves splitting the array into equally sized blocks (say, *m* elements each) and precomputing the minimum in each block. This precomputation will take Θ(*n*) time, since it takes Θ(*m*) time to find the minimum in each block, and there are Θ(*n* / *m*) blocks.

After this, when we are given some query [*a*,*b*), we note that this can be written as the union of the intervals [*a*,*c*_{0}),[*c*_{0},*c*_{1}),[*c*_{1},*c*_{2}),...,[*c*_{k − 1},*c*_{k}),[*c*_{k},*b*), where all the intervals except for the first and last are individual blocks. If we can find the minimum in each of these subintervals, the smallest of those values will be the minimum in [*a*,*b*). But because all the intervals in the middle (note that there may be zero of these if *a* and *b* are in the same block) are blocks, their minima can simply be looked up in constant time.

Observe that the intermediate intervals are *O*(*n* / *m*) in number (because there are only about *n* / *m* blocks in total). Furthermore, if we pick *c*_{0} at the nearest available block boundary, and likewise with *c*_{k}, then the intervals [*a*,*c*_{0}) and [*c*_{k},*b*) have size *O*(*m*) (since they do not cross block boundaries). By taking the minimum of all the precomputed block minima, and the elements in [*a*,*c*_{0}) and [*c*_{k},*b*), the answer is obtained in *O*(*m* + *n* / *m*) time. If we choose a block size of , we obtain overall.

### [edit] Segment tree

While is not optimal, it is certainly better than linear time, and suggests that we might be able to do better using precomputation. Instead of dividing the array into pieces, we might consider dividing it in half, and then dividing each half in half, and dividing each quarter in half, and so on. The resulting structure of intervals and subintervals is a segment tree. It uses linear space and requires linear time to construct; and once it has been built, any query can be answered in *O*(log*N*) time.

### [edit] Sparse table

(Namely due to ^{[1]}.) At the expense of space and preprocessing time, we can even answer queries in *O*(1) using dynamic programming. Define *M*_{i,k} to be the minimum of the elements (or as many of those elements as actually exist); that is, the elements in an interval of size 2^{k} starting from *i*. Then, we see that *M*_{i,0} = *A*_{i} for each *i*, and ; that is, the minimum in an interval of size 2^{k + 1} is the smaller of the minima of the two halves of which it is composed, of size 2^{k}. Thus, each entry of *M* can be computed in constant time, and in total *M* has about entries (since values of *k* for which 2^{k} > *n* are not useful). Then, given the query [*a*,*b*), simply find *k* such that [*a*,*a* + 2^{k}) and [*b* − 2^{k},*b*) overlap but are contained within [*a*,*b*); then we already know the minima in each of these two sub-intervals, and since they cover the query interval, the smaller of the two is the overall minimum. It's not too hard to see that the desired *k* is ; and then the answer is .

### [edit] Cartesian trees

We can get the best of both worlds—that is, constant query time and linear preprocessing time and space—but the algorithm is somewhat more involved. It combines the block-based approach, the sparse table approach, and the use of Cartesian trees.

We observe that some minimum in a range in the given array occurs at the same place as the lowest common ancestor of the two nodes corresponding to the endpoints of the range in the Cartesian tree of the array. That is, if elements *A*_{i} and *A*_{j} occur at nodes *u* and *v* in the Cartesian tree of *A*, then there is some *A*_{k} in the range *A*_{i..j} such that the element *A*_{k} occurs at the lowest common ancestor of *u* and *v* in the Cartesian tree.

*Proof*: An inorder traversal of the Cartesian tree gives the original array. Thus, consider the segment *S* of the inorder traversal beginning when *u* is visited and *v* is visited (*u* and *v* are as above); this must be equivalent to the segment of the array *A*_{i..j}. Now, if the LCA of *u* and *v* is *u*, then *v* is in its right subtree; but *S* must then contain only *u* and elements from *u*'s right subtree, since all nodes in *S*'s right subtree (including *v*) will be visited immediately after *u* itself; so that all nodes in *S* are descendants of *u*. Likewise, if *v* is the LCA, then *S* consists entirely of descendants of *v*. If the LCA is neither *u* nor *v*, then *u* must occur in its left subtree and *v* in its right subtree (because if they both occurred in the same subtree, then the root of that subtree would be a lower common ancestor, a contradiction). But all elements in the left subtree of the LCA, including *u* are visited immediately before the LCA, and all elements in the right, including *v*, are visited immediately after the LCA, and hence, again, all nodes in *S* are descendants of the LCA. Now, the labels on the nodes in *S* correspond to the elements *A*_{i},...,*A*_{j}, and all nodes in *S* have labels less than or equal to the label of the LCA, since Cartesian trees are min-heap-ordered; so it follows that the label of the LCA is the minimum element in the range.

Cartesian trees may be constructed in linear time and space, so we are within our *O*(*n*) preprocessing bound so far; we just need to solve the LCA problem on the Cartesian tree. We will do this, curiously enough, by reducing it back to RMQ (with linear preprocessing time) using the technique described in the Lowest common ancestor article. However, the array derived from the LCA-to-RMQ reduction (which we'll call *B*) has the property that any two adjacent elements differ by +1 or -1. We now focus on how to solve this restricted form of RMQ with linear preprocessing time and constant query time.

First, divide *B* into blocks of size roughly . Find the minimum element in each block and construct an array *C* such that *C*_{0} is the minimum in the leftmost block, *C*_{1} in the second-leftmost block, and so on. Construct a sparse table from array *C*. Now, if we are given a range consisting of any number of consecutive blocks in *B*, then the minimum of this range is given by the minimum of the corresponding minima in *C*---and, since we have constructed the sparse table of *C*, this query can be answered in constant time. Array *C* has size , so its sparse table is computed using time and space .

Now consider an individual block of *B*. If we fix the first element of this block, then there are possible combinations of values for the entire block, since with each following element we have a choice between two alternatives (it is either greater or less than the previous element by 1). Say that two blocks have the same *kind* if their corresponding elements differ by a constant (*e.g.*, [2,1,2,3,4] and [0,-1,0,1,2] are of the same kind). Hence there are only different kinds of blocks; and, furthermore, all blocks of a given kind have their minimum in the same position, regardless of the actual values of the elements. Therefore, for each kind of block, we will naively precompute all possible range minimum queries for that block. But each block has size , so the precomputation uses space and time; and in total there are blocks, so in total this precomputation stage uses space and time. Finally, for each block in *B*, compute its kind, and store the result in another auxiliary array *D*. (This will use linear time and *O*(*n* / *m*) space.)

Now, we use the block-based approach to answering a query. We divide the interval given up into at most three subintervals. The first goes from the initial element to the last element of its block; the second spans zero or more complete blocks; and the third ends at the final element of the given interval and begins at the first element of its block. The minimum element is in one of these three subintervals. To find the minimum in the first subinterval, we look up the kind of block it is contained in (using array *D*), and then look up the precomputed position of the minimum in the desired range for that specific kind of block; and finally we look up the value at that position in *B*. We do something similar for the third subinterval. For the second subinterval, we use the sparse table lookup discussed two paragraphs above. The query is answered in constant time overall.

## [edit] Dynamic

The block-based solution handles the dynamic case as well; we must simply remember, whenever we update an element, to recompute the minimum element in the block it is in. This gives time per update, and, assuming a uniform random distribution of updates, the expected update time is *O*(1). This is because if we decrease an element, we need only check whether the new value is less than the current minimum (constant time), whereas if we increase an element, we only need to recompute the minimum if the element updated was the minimum before (which takes time but has a probability of occurring of only ). Unfortunately, the query still has average-case time .

The segment tree can be computed in linear time and allows both queries and updates to be answered in *O*(log*n*) time. It also allows, with some cleverness, entire ranges to be updated at once (efficiently). Analysis of the average case is left as an exercise to the reader.

We can also use any balanced binary tree (or dictionary data structure such as a skip-list) and augment it to support range minimum query operations with O(log n) per Update (Insert/Delete) as well as Query.

## [edit] References

Much of the information in this article was drawn from a single source:

- ↑ "Range Minimum Query and Lowest Common Ancestor". (n.d.). Retrieved from http://community.topcoder.com/tc?module=Static&d1=tutorials&d2=lowestCommonAncestor#Range_Minimum_Query_%28RMQ%29